// ObjectKnowledge.h: ObjectKnowledge class implementation
// Stores information about known physical objects in the world 
//
//////////////////////////////////////////////////////////////////////

#ifndef __ObjectKnowledge_H__
#define __ObjectKnowledge_H__

#include "RobotType.h"


/*
#define STUFF				00
*/


/////////////////////////////////////////////////////////////////////////////
// class CObjectInfo
// information about a given real-world object

class ObjectInfo
{

public:
//	ObjectInfo();

protected:


public:

	int				nIndex;
	CvSeq			*Keypoints;		// For SURF matching
	CvSeq			*Descriptors;	// For SURF matching
	CvMemStorage	*Storage;		// For SURF matching
	CString			strImageFileName;
	CString			strObjectName;
	CString			strGenericObjectName;
	CString			strComment;
	CString			strPrompt;
	CString			strUserResponseNo;
	CString			strUserResponseYes;

};

typedef CTypedPtrList<CPtrList, ObjectInfo*>	ObjectInfoList;


/////////////////////////////////////////////////////////////////////////////
class ObjectKnowledge
{


public:


	ObjectKnowledge::ObjectKnowledge();

	ObjectKnowledge::~ObjectKnowledge();


private:

	ObjectInfoList	m_ObjectInfoList;
	BOOL			m_initialized;

public:

	void ObjectKnowledge::Init();
	void LoadKnownObjects( char* FileName );
	void SaveToTextFile( char* FileName );
	void AddObjectToList( ObjectInfo* pObjectInfo ); 
	ObjectInfo *GetObjectAt( POSITION Pos ) ;

	void DeleteAllObjects();

	ObjectInfoList* GetObjectInfoList()  { return &m_ObjectInfoList; }
};

#endif  // define __ObjectKnowledge_H__

