// WiiControl.h: Wii Remote Control class
//////////////////////////////////////////////////////////////////////
#pragma once	// Only include this header once

#include "RobotType.h"

#define SERVO_CHANGE_TENTH_DEGREES	150		// Tenth degrees per update

/////////////////////////////////////////////////////////////////////////////
class WiiControl
{

public:


	WiiControl::WiiControl();
	WiiControl::~WiiControl();

	//-----------------------------------------------------------------------------
	// Name: Initialize
	// Desc: Initialize Wii Control
	//-----------------------------------------------------------------------------
	void Initialize();

	// ------------------------------------------------------------------------------------
	// Name: Update
	// Desc: Get updated status from the Wii Control, and sends commands as needed
	//-------------------------------------------------------------------------------------
	void Update();



private:

	HANDLE			m_hMapFile;
	LPCTSTR			m_pBuf;	// Shared Buffer space
	WIIMOTE_STATUS_T m_WiiMoteStatus;

	BOOL			m_bWiiMoteSharedMemoryOpened;
	BOOL			m_bWiiHasMotorControl;		// Keep track if Wii is controlling or something else
	BOOL			m_bWiiHasHeadControl;
	BOOL			m_SpeechRecoPausedByWii;
	BOOL			m_bSpeakingToChild;
	int 			m_PhraseToSpeak;
	BOOL			m_FaceTrackingEnabledByWii;
	int 			m_OldPanSpeed;
	int 			m_OldTiltSpeed;
	int 			m_OldSideTiltSpeed;
	int 			m_ManualArmControlRight;
	int 			m_ManualArmControlLeft;
	ArmControl	   *m_pArmControlRight;
	ArmControl	   *m_pArmControlLeft;
	HeadControl	   *m_pHeadControl;	// For controlling head servos

};

